		.include "tn13def.inc"
		.DSEG		;  
vremia1:.byte	1 ;r18
vremia2:.byte	1 ;r18
timekn:.byte	1 ;r18
ring:.byte	1 ;r18

		.CSEG
		.org 0                 ;    
		rjmp reset          ;    reset
		.org 1
		reti ;Interr
		.org 2
		reti ;Pin Change Interrupt0
		.org 3
		rjmp Match 
		.org 4
		reti ;EEPROM write complete
		.org 5
		reti ;Analog Comparator Interrupt
		.org 6
		reti ;Timer_Counter0A; Compare Match A
		.org 7
		reti ;Timer_Counter0B; Compare Match B
		.org 8
		reti ;Watchdog Timeout
		.org 9
		reti ;conversion;ADC Conversion Complete Handle 

reset:	wdr; Reset Watchdog Timer
		ldi r16,24
		out WDTCR, r16;
		ldi r16,12 
		out WDTCR, r16;
		;--------------------
		LDI	ZL,Low(SRAM_START)	;     
		LDI	ZH,High(SRAM_START)
		CLR	R16			;  R16
Flush:	ST 	Z+,R16			;  0   
		CPI	ZH,High(RAMEND+1)	;   ?
		BRNE	Flush			; ?  !
		CPI	ZL,Low(RAMEND+1)	;     ?
		BRNE	Flush
		CLR	ZL			;  
		CLR	ZH
		LDI	ZL, 30		;    	
		CLR	ZH		;      
		DEC	ZL		;  
		ST	Z, ZH		;    0
		BRNE	PC-2		;      		
		ldi r16, RAMEND ;   r16    
		out SPL, r16
;-------------------------------------------------------------
		ldi r16,14   ;  r16 
		out DDRB,r16  ;   


		ldi r16,17   ;  r16 
		out PORTB,r16  ;          

		ldi r16,(1<<CS00);   r16    CS01
		out TCCR0B,r16 ;     0  8
		ldi r16,2
		out TIMSK0, r16;  0
;---------------------- EEPROM_read ---------------------------------------

		rcall EEPROM_read
		cpi r16,20
		brsh wr0
		mov r29, r16
		rjmp main
wr0:    clr r29 ;  r29 H


;---------------------- EEPROM_read end---------------------------------------


main:	sei
		wdr
		sbrc r22,0  ;    r22.0  
		rjmp main
		sbr r22,1 ;    r22,0

		cpi r20,23 ;  50
		brsh mainX;     ( )
		inc r20      ;   1 r20
		rjmp main
mainX:	clr r20      ;  r20  


;----------- pfram -----------------------------------------------
		mov r16,r19 ;r19  16
		andi r16,7
		cpi r16, 0 ;  
		breq equall ; -   

		sbrc r19,3  ;    r19.3  
		rjmp allar
		sbr r19,8 ;    r19,3
		cbi PORTB,1 ;
		cbi PORTB,2 ;
		clr r30      ;  r30  L
		clr r31      ;  r31  H
		cpi r16,1 ;  r19  1
		breq allar ;-   

		cpi r16,2 ;  r19  1
		breq pls ;-   

		cpi r16,4 ;  r19  1
		breq min ;-   
		rjmp alendd

pls:
		cpi r29,19 ;  r29  19
		breq pls0 ;-   
		inc r29      ;   1 r29
pls01:	mov r16,r29
		ldi r17,0
		rcall EEPROM_write
		rjmp allar
pls0:	ldi r29,0
		rjmp pls01


min:
		cpi r29,0 ;  r29  0
		breq min0 ;-   
		dec r29      ;   1 r29
min01:	mov r16,r29
		ldi r17,0
		rcall EEPROM_write
		rjmp allar
min0:	ldi r29,19
		rjmp min01

;------------
equall:	rjmp equal
;------------

allar:
		sbrc r19,4  ;    r19.4  
		rjmp allar0
		sbr r19,16 ;    r19,4		
		mov r30,r29 ;r29  r30
		inc r30      ;   1 r30

		cpi r30,20 ;   
		brsh alldva;     ( )

		cpi r30,10 ;   
		brsh alldes;     ( )
		rjmp allar0

alldva:ldi r31,2
		subi r30,20;-   
		rjmp allar0

alldes:ldi r31,1
		subi r30,10;-   
		rjmp allar0
allar0:

		cpi r31,0 ; bip  
		breq algty ; -   

		lds r18,ring
		cpi r18,0 ; bip  
		brne alfgf ; -    
		dec r31  ;   1 r31
		ldi r18, 26
		rjmp alfgf

algty:
		cpi r30,0 ; bip  
		breq alfgf ; -   

		lds r18,ring
		cpi r18,0 ; bip  
		brne alfgf ; -    
		dec r30  ;   1 r30
		ldi r18, 12
		rjmp alfgf


alfgf:	cpi r18,0 ; bip  
		breq alend ; -   

		cpi r18,8 ;   bip
		brlo alltih;   ( )

		sbi PORTB,3 ;
		rjmp alltihd
alltih:	cbi PORTB,3 ;
alltihd:dec r18  ;   1 r18
		sts ring,r18


alend:
		cpi r31,0 ; bip
		brne main1 ; -    
		cpi r30,0 ; bip
		brne main1 ; -    
		cpi r18,0 ; bip
		brne main1 ; -    

alendd:	clr r19      ;  r19
		rjmp reset
main1:
		rjmp main

;----------- led ---------------------------------------------------

equal:	sbrc r21,0  ;    r21.0  
		rjmp flcd
		inc r25      ;   1 r25
		cpi r25,16 ;  r25  16
		brlo blkflcd    ;   r25 < 6 ( )
		clr r25      ;  r25
		sbr r21,1 ;    r21,0
		rjmp blkflcd
flcd:
		sbrc r21,1  ;    r21.1  
		rjmp flcd1
		sbr r21,2 ;    r21,1
		sbi PORTB,1 ;
		rjmp blkflcd
flcd1:
		sbrc r21,2  ;    r21.2  
		rjmp flcd2
		sbr r21,4 ;    r21,2
		cbi PORTB,1 ;
		rjmp blkflcd
flcd2:
		sbrc r21,3  ;    r21.3  
		rjmp flcd3
		sbr r21,8 ;    r21,3
		sbi PORTB,1 ;
		rjmp blkflcd
flcd3:
		cbi PORTB,1 ;
		cbr r21,15 ;o   
		rjmp blkflcd

blkflcd:
		sbrs r21,4  ;    r21.4  
		rjmp loop


		sbic PORTB,2 ;     PORTB,2 
		rjmp rtyr
		sbi PORTB,2 ;
		rjmp loop
rtyr:	cbi PORTB,2 ;


;----------- led end------------------------------------------------------


loop:

		lds r18,vremia1
		sbic PINB,0 ;      I/O  
		rjmp tdfg1 ;  ,    1
		sbrc r22,4 ;     r22  sbrs r22,4 
		rjmp tdfg0
vdfod:	cpi r18,4 ;  
		brsh hdd ;     ( )
		inc r18
		sbrc r22,5  ;    r22.5 
		cbr r22,32 ;    r22,5
		rjmp grety
tdfg1:	sbrc r22,4 ;     r22  4
		rjmp vdfod
		sbr r22,16 ;    r22,4
		ldi r18,0
		rjmp vdfod
tdfg0:	cbr r22,16   ;    r22,4 
		ldi r18,0
		rjmp vdfod
hdd:
		sbrc r22,5  ;    r22.5  
		rjmp grety
		sbr r22,32 ;    r22,5
		sbrc r22,4  ;    r22.4  
		rjmp ydf1
		sbr r22,64 ;    r22,6 
		rjmp grety
ydf1:
		cbr r22,64 ;    r22,6
grety:	sts vremia1,r18

		sbrs r22,6  ;    r22.6  
		rjmp knfin
		sbr r22,128 ;    r22,7
		lds r18,timekn
		cpi r18,80 ;   
		brsh knfof;     ( )
		inc r18      ;   1 r18
		sts timekn,r18
		rjmp knfof
knfin:

		sbrs r22,7  ;    r22.7  
		rjmp knfof
		cbr r22,128 ;    r22,7
		lds r18,timekn

		cpi r18,2 ;   
		brlo kndel;   ( )

		cpi r18,70 ;   
		brsh kndel;     ( )


		cpi r18,40 ;   
		brlo knnext;   ( )
		sbr r19,4 ;    r19,2 ---
		rjmp kndel

knnext:	cpi r18,18 ;   
		brlo knnebi;   ( )
		sbr r19,2 ;    r19,1  ---
		rjmp kndel

knnebi:
		sbr r19,1 ;    r19,0  --- 


kndel:	clr r18     ;  r18  timekn
		sts timekn,r18

knfof:


;------------------- PIR ------------------------------
		lds r18,vremia2
		sbic PINB,4 ;      I/O  
		rjmp trig1 ;  ,    1
		sbrc r22,1 ;     r22  sbrs r22,1 
		rjmp trig0
vihod:	cpi r18,4 ;  
		brsh hod ;     ( )
		inc r18
		sbrc r22,2  ;    r22.2 
		cbr r22,4 ;    r22,2
		rjmp tpovorot
trig1:	sbrc r22,1 ;     r22  1
		rjmp vihod
		sbr r22,2 ;    r22,1
		ldi r18,0
		rjmp vihod
trig0:	cbr r22,2   ;    r22,1 
		ldi r18,0
		rjmp vihod
hod:
		sbrc r22,2  ;    r22.2  
		rjmp tpovorot
		sbr r22,4 ;    r22,2
		sbrc r22,1  ;    r22.1  
		rjmp yst1
		sbr r22,8 ;    r22,3 
		rjmp tpovorot
yst1:
		cbr r22,8 ;    r22,3
tpovorot:sts vremia2,r18


		sbrs r22,3  ;    r22.3  
		rjmp minus
		sbr r21,16 ;    r21,4
		clr r26      ;  r26  L
		clr r27      ;  r27  H
 


minus:
		sbrs r21,4  ;    r21.4  
		rjmp main
;-------- bip ---------------

		sbrc r21,5  ;    r21.5  
		rjmp bip
		sbi PORTB,3 ;
		cpi r24,2 ;  
		brsh bipof;     ( )
		inc r24      ;   1 r24
		rjmp mimpr
bipof:	clr r24      ;  r24  
		sbr r21,32 ;    r21,5
		rjmp mimpr
bip:
		sbrc r21,6  ;    r21.6  
		rjmp bip1
		sbr r21,64 ;    r21,6
		cbi PORTB,3 ;


bip1:
		sbrc r21,7  ;    r21.7  
		rjmp mimpr
		cpi r23,2
		brsh bipstof;     ( )
		inc r23      ;   1 r24
		cbr r21,96 ;o   
		rjmp mimpr

bipstof:clr r23      ;  r23 
		sbr r21,128 ;    r21,7

;-------- bip end ---------------

mimpr:

		cp r27,r29 ;  -     (H)
		brsh lows;     ( )		
		cpi r26,180
		brne mhc ;   
		clr r26      ;  r26  L
		inc r27      ;   1 r27
mhc:	inc r26      ;   1 r26
		rjmp main

lows:
		cpi r26,180; -     (L)
		brsh ress;     ( )
		inc r26      ;   1 r26
		rjmp main
ress:

		cbr r21,240 ;o    4.5.6.7
		cbi PORTB,2 ;
		rjmp main
;-------------------------------------------------------------


Match:
		push r16   ;  r16  
		in r16, sreg
		push r16   ;  r16  
		cbr r22,1 ;    r22,0
		pop  r16     ;  r16
		out sreg, r16
		pop  r16     ;  r16
		reti


;-------------------------------------------------------------


EEPROM_write:cli
		wdr
		sbic EECR,EEPE ; Wait for completion of previous write
		rjmp EEPROM_write 
		push r17
		ldi r17, (0<<EEPM1)|(0<<EEPM0) ; Set Programming mode
		out EECR, r17
		pop r17
		out EEARL, r17 ; Set up address (r17) in address register
		out EEDR,r16 ; Write data (r16) to data register
		sbi EECR,EEMPE ; Write logical one to EEMPE
		sbi EECR,EEPE ; Start eeprom write by setting EEPE
		reti

EEPROM_read:cli
		wdr
		sbic EECR,EEPE ; Wait for completion of previous write
		rjmp EEPROM_read
		out EEARL, r17 ; Set up address (r17) in address register
		sbi EECR,EERE ; Start eeprom read by writing EERE
		in r16,EEDR ; Read data from data register
		reti
